<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd">
<!--NewPage-->
<HTML>
<HEAD>
<!-- Generated by javadoc (build 1.5.0_06) on Wed Aug 20 17:16:46 PDT 2008 -->
<TITLE>
Lists (Google Collections Library - snapshot-20080820 (ALPHA))
</TITLE>

<META NAME="keywords" CONTENT="com.google.common.collect.Lists class">

<LINK REL ="stylesheet" TYPE="text/css" HREF="../../../../stylesheet.css" TITLE="Style">

<SCRIPT type="text/javascript">
function windowTitle()
{
    parent.document.title="Lists (Google Collections Library - snapshot-20080820 (ALPHA))";
}
</SCRIPT>
<NOSCRIPT>
</NOSCRIPT>

</HEAD>

<BODY BGCOLOR="white" onload="windowTitle();">


<!-- ========= START OF TOP NAVBAR ======= -->
<A NAME="navbar_top"><!-- --></A>
<A HREF="#skip-navbar_top" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_top_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/ListMultimap.html" title="interface in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/MapConstraint.html" title="interface in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/Lists.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Lists.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_top"></A>
<!-- ========= END OF TOP NAVBAR ========= -->

<HR>
<!-- ======== START OF CLASS DATA ======== -->
<H2>
<FONT SIZE="-1">
com.google.common.collect</FONT>
<BR>
Class Lists</H2>
<PRE>
<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">java.lang.Object</A>
  <IMG SRC="../../../../resources/inherit.gif" ALT="extended by "><B>com.google.common.collect.Lists</B>
</PRE>
<HR>
<DL>
<DT><PRE>public final class <B>Lists</B><DT>extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></DL>
</PRE>

<P>
Static utility methods pertaining to <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util"><CODE>List</CODE></A> instances. Also see this
 class's counterparts <A HREF="../../../../com/google/common/collect/Sets.html" title="class in com.google.common.collect"><CODE>Sets</CODE></A> and <A HREF="../../../../com/google/common/collect/Maps.html" title="class in com.google.common.collect"><CODE>Maps</CODE></A>.
<P>

<P>
<DL>
<DT><B>Author:</B></DT>
  <DD>Kevin Bourrillion, Mike Bostock</DD>
</DL>
<HR>

<P>

<!-- ========== METHOD SUMMARY =========== -->

<A NAME="method_summary"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="2"><FONT SIZE="+2">
<B>Method Summary</B></FONT></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#asList(E, E[])">asList</A></B>(E&nbsp;first,
       E[]&nbsp;rest)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns an unmodifiable list containing the specified first element and
 backed by the specified array of additional elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#asList(E, E, E[])">asList</A></B>(E&nbsp;first,
       E&nbsp;second,
       E[]&nbsp;rest)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns an unmodifiable list containing the specified first and second
 element, and backed by the specified array of additional elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#newArrayList()">newArrayList</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an empty <code>ArrayList</code> instance.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#newArrayList(E...)">newArrayList</A></B>(E...&nbsp;elements)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an <code>ArrayList</code> instance containing the given elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#newArrayList(java.lang.Iterable)">newArrayList</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends E&gt;&nbsp;elements)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an <code>ArrayList</code> instance containing the given elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#newArrayList(java.util.Iterator)">newArrayList</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Iterator.html" title="class or interface in java.util">Iterator</A>&lt;? extends E&gt;&nbsp;elements)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an <code>ArrayList</code> instance containing the given elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#newArrayListWithExpectedSize(int)">newArrayListWithExpectedSize</A></B>(int&nbsp;expectedSize)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an <code>ArrayList</code> instance with the given expected size.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/LinkedList.html" title="class or interface in java.util">LinkedList</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#newLinkedList()">newLinkedList</A></B>()</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates an empty <code>LinkedList</code> instance.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/LinkedList.html" title="class or interface in java.util">LinkedList</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#newLinkedList(java.lang.Iterable)">newLinkedList</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends E&gt;&nbsp;elements)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Creates a <code>LinkedList</code> instance containing the given elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt;
<BR>
<A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#sortedCopy(java.lang.Iterable)">sortedCopy</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;E&gt;&nbsp;iterable)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a copy of the given iterable sorted by the natural ordering of its
 elements.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#sortedCopy(java.lang.Iterable, java.util.Comparator)">sortedCopy</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;E&gt;&nbsp;iterable,
           <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super E&gt;&nbsp;comparator)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a copy of the given iterable sorted by an explicit comparator.</TD>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD ALIGN="right" VALIGN="top" WIDTH="1%"><FONT SIZE="-1">
<CODE>static
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="0" SUMMARY="">
<TR ALIGN="right" VALIGN="">
<TD NOWRAP><FONT SIZE="-1">
<CODE>&lt;F,T&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;T&gt;</CODE></FONT></TD>
</TR>
</TABLE>
</CODE></FONT></TD>
<TD><CODE><B><A HREF="../../../../com/google/common/collect/Lists.html#transform(java.util.List, com.google.common.base.Function)">transform</A></B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;F&gt;&nbsp;fromList,
          <A HREF="../../../../com/google/common/base/Function.html" title="interface in com.google.common.base">Function</A>&lt;? super F,? extends T&gt;&nbsp;function)</CODE>

<BR>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;Returns a list that applies <code>function</code> to each element of <code>fromList</code>.</TD>
</TR>
</TABLE>
&nbsp;<A NAME="methods_inherited_from_class_java.lang.Object"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#EEEEFF" CLASS="TableSubHeadingColor">
<TH ALIGN="left"><B>Methods inherited from class java.lang.<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html" title="class or interface in java.lang">Object</A></B></TH>
</TR>
<TR BGCOLOR="white" CLASS="TableRowColor">
<TD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#clone()" title="class or interface in java.lang">clone</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#equals(java.lang.Object)" title="class or interface in java.lang">equals</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#finalize()" title="class or interface in java.lang">finalize</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#getClass()" title="class or interface in java.lang">getClass</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#hashCode()" title="class or interface in java.lang">hashCode</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notify()" title="class or interface in java.lang">notify</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#notifyAll()" title="class or interface in java.lang">notifyAll</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#toString()" title="class or interface in java.lang">toString</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait()" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long)" title="class or interface in java.lang">wait</A>, <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Object.html#wait(long, int)" title="class or interface in java.lang">wait</A></CODE></TD>
</TR>
</TABLE>
&nbsp;
<P>

<!-- ============ METHOD DETAIL ========== -->

<A NAME="method_detail"><!-- --></A>
<TABLE BORDER="1" WIDTH="100%" CELLPADDING="3" CELLSPACING="0" SUMMARY="">
<TR BGCOLOR="#CCCCFF" CLASS="TableHeadingColor">
<TH ALIGN="left" COLSPAN="1"><FONT SIZE="+2">
<B>Method Detail</B></FONT></TH>
</TR>
</TABLE>

<A NAME="newArrayList()"><!-- --></A><H3>
newArrayList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt; <B>newArrayList</B>()</PRE>
<DL>
<DD>Creates an empty <code>ArrayList</code> instance.

 <p><b>Note:</b> if you need an immutable empty list, use <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collections.html#emptyList()" title="class or interface in java.util"><CODE>Collections.emptyList()</CODE></A> instead.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>a newly-created, initially-empty <code>ArrayList</code></DL>
</DD>
</DL>
<HR>

<A NAME="newArrayList(java.lang.Object)"><!-- --></A><A NAME="newArrayList(E...)"><!-- --></A><H3>
newArrayList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt; <B>newArrayList</B>(E...&nbsp;elements)</PRE>
<DL>
<DD>Creates an <code>ArrayList</code> instance containing the given elements.

 <p><b>Note:</b> if you need an immutable List, use <A HREF="../../../../com/google/common/collect/ImmutableList.html" title="class in com.google.common.collect"><CODE>ImmutableList</CODE></A>
 instead.

 <p><b>Note:</b> due to a bug in javac 1.5.0_06, we cannot support the
 following:

 <p><code>List&lt;Base&gt; list = Lists.newArrayList(sub1, sub2);</code>

 <p>where <code>sub1</code> and <code>sub2</code> are references to subtypes of <code>Base</code>, not of <code>Base</code> itself. To get around this, you must use:

 <p><code>List&lt;Base&gt; list = Lists.&lt;Base&gt;newArrayList(sub1, sub2);</code>
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>elements</CODE> - the elements that the list should contain, in order
<DT><B>Returns:</B><DD>a newly-created <code>ArrayList</code> containing those elements</DL>
</DD>
</DL>
<HR>

<A NAME="newArrayList(java.lang.Iterable)"><!-- --></A><H3>
newArrayList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt; <B>newArrayList</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends E&gt;&nbsp;elements)</PRE>
<DL>
<DD>Creates an <code>ArrayList</code> instance containing the given elements.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>elements</CODE> - the elements that the list should contain, in order
<DT><B>Returns:</B><DD>a newly-created <code>ArrayList</code> containing those elements</DL>
</DD>
</DL>
<HR>

<A NAME="newArrayList(java.util.Iterator)"><!-- --></A><H3>
newArrayList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt; <B>newArrayList</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/Iterator.html" title="class or interface in java.util">Iterator</A>&lt;? extends E&gt;&nbsp;elements)</PRE>
<DL>
<DD>Creates an <code>ArrayList</code> instance containing the given elements.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>elements</CODE> - the elements that the list should contain, in order
<DT><B>Returns:</B><DD>a newly-created <code>ArrayList</code> containing those elements</DL>
</DD>
</DL>
<HR>

<A NAME="newArrayListWithExpectedSize(int)"><!-- --></A><H3>
newArrayListWithExpectedSize</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/ArrayList.html" title="class or interface in java.util">ArrayList</A>&lt;E&gt; <B>newArrayListWithExpectedSize</B>(int&nbsp;expectedSize)</PRE>
<DL>
<DD>Creates an <code>ArrayList</code> instance with the given expected size.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>expectedSize</CODE> - the expected size of the list
<DT><B>Returns:</B><DD>a newly-created, initially empty <code>ArrayList</code> with enough
     capacity for the given expected size
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/IllegalArgumentException.html" title="class or interface in java.lang">IllegalArgumentException</A></CODE> - if the specified expected size is negative</DL>
</DD>
</DL>
<HR>

<A NAME="newLinkedList()"><!-- --></A><H3>
newLinkedList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/LinkedList.html" title="class or interface in java.util">LinkedList</A>&lt;E&gt; <B>newLinkedList</B>()</PRE>
<DL>
<DD>Creates an empty <code>LinkedList</code> instance.

 <p><b>Note:</b> if you need an immutable empty <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util"><CODE>List</CODE></A>, use
 <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Collections.html#emptyList()" title="class or interface in java.util"><CODE>Collections.emptyList()</CODE></A> instead.
<P>
<DD><DL>

<DT><B>Returns:</B><DD>a newly-created, initially-empty <code>LinkedList</code></DL>
</DD>
</DL>
<HR>

<A NAME="newLinkedList(java.lang.Iterable)"><!-- --></A><H3>
newLinkedList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/LinkedList.html" title="class or interface in java.util">LinkedList</A>&lt;E&gt; <B>newLinkedList</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;? extends E&gt;&nbsp;elements)</PRE>
<DL>
<DD>Creates a <code>LinkedList</code> instance containing the given elements.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>elements</CODE> - the elements that the list should contain, in order
<DT><B>Returns:</B><DD>a newly-created <code>LinkedList</code> containing those elements</DL>
</DD>
</DL>
<HR>

<A NAME="sortedCopy(java.lang.Iterable)"><!-- --></A><H3>
sortedCopy</H3>
<PRE>
public static &lt;E extends <A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Comparable.html" title="class or interface in java.lang">Comparable</A>&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt; <B>sortedCopy</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;E&gt;&nbsp;iterable)</PRE>
<DL>
<DD>Returns a copy of the given iterable sorted by the natural ordering of its
 elements. The input is not modified. The returned list is modifiable,
 serializable, and implements <A HREF="http://java.sun.com/javase/6/docs/api/java/util/RandomAccess.html" title="class or interface in java.util"><CODE>RandomAccess</CODE></A>.

 <p>Unlike <A HREF="../../../../com/google/common/collect/Sets.html#newTreeSet(java.lang.Iterable)"><CODE>Sets.newTreeSet(Iterable)</CODE></A>, this method does not collapse
 equal elements, and the resulting collection does not maintain its own sort
 order.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>iterable</CODE> - the elements to be copied and sorted
<DT><B>Returns:</B><DD>a new list containing the given elements in sorted order
<DT><B>Throws:</B>
<DD><CODE><A HREF="http://java.sun.com/javase/6/docs/api/java/lang/ClassCastException.html" title="class or interface in java.lang">ClassCastException</A></CODE> - if <code>iterable</code> contains elements that are
     not mutually comparable</DL>
</DD>
</DL>
<HR>

<A NAME="sortedCopy(java.lang.Iterable, java.util.Comparator)"><!-- --></A><H3>
sortedCopy</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt; <B>sortedCopy</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/lang/Iterable.html" title="class or interface in java.lang">Iterable</A>&lt;E&gt;&nbsp;iterable,
                                     <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Comparator.html" title="class or interface in java.util">Comparator</A>&lt;? super E&gt;&nbsp;comparator)</PRE>
<DL>
<DD>Returns a copy of the given iterable sorted by an explicit comparator. The
 input is not modified. The returned list is modifiable, serializable, and
 implements <A HREF="http://java.sun.com/javase/6/docs/api/java/util/RandomAccess.html" title="class or interface in java.util"><CODE>RandomAccess</CODE></A>.

 <p>Unlike <A HREF="../../../../com/google/common/collect/Sets.html#newTreeSet(java.util.Comparator, java.lang.Iterable)"><CODE>Sets.newTreeSet(Comparator, Iterable)</CODE></A>, this method does
 not collapse elements that the comparator treats as equal, and the
 resulting collection does not maintain its own sort order.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>iterable</CODE> - the elements to be copied and sorted<DD><CODE>comparator</CODE> - a comparator capable of sorting the given elements
<DT><B>Returns:</B><DD>a new list containing the given elements in sorted order</DL>
</DD>
</DL>
<HR>

<A NAME="asList(java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="asList(E, E[])"><!-- --></A><H3>
asList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt; <B>asList</B>(<FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                                 E&nbsp;first,
                                 E[]&nbsp;rest)</PRE>
<DL>
<DD>Returns an unmodifiable list containing the specified first element and
 backed by the specified array of additional elements. Changes to the <code>rest</code> array will be reflected in the returned list. Unlike <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Arrays.html#asList(T...)" title="class or interface in java.util"><CODE>Arrays.asList(T...)</CODE></A>, the returned list is unmodifiable.

 <p>This is useful when a varargs method needs to use a signature such as
 <code>(Foo firstFoo, Foo... moreFoos)</code>, in order to avoid overload
 ambiguity or to enforce a minimum argument count.

 <p>The returned list is serializable and implements <A HREF="http://java.sun.com/javase/6/docs/api/java/util/RandomAccess.html" title="class or interface in java.util"><CODE>RandomAccess</CODE></A>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>first</CODE> - the first element<DD><CODE>rest</CODE> - an array of additional elements, possibly empty
<DT><B>Returns:</B><DD>an unmodifiable list containing the specified elements</DL>
</DD>
</DL>
<HR>

<A NAME="asList(java.lang.Object,java.lang.Object,java.lang.Object)"><!-- --></A><A NAME="asList(E, E, E[])"><!-- --></A><H3>
asList</H3>
<PRE>
public static &lt;E&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;E&gt; <B>asList</B>(<FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                                 E&nbsp;first,
                                 <FONT SIZE="-1"><A HREF="../../../../com/google/common/base/Nullable.html" title="annotation in com.google.common.base">@Nullable</A></FONT>
                                 E&nbsp;second,
                                 E[]&nbsp;rest)</PRE>
<DL>
<DD>Returns an unmodifiable list containing the specified first and second
 element, and backed by the specified array of additional elements. Changes
 to the <code>rest</code> array will be reflected in the returned list. Unlike
 <A HREF="http://java.sun.com/javase/6/docs/api/java/util/Arrays.html#asList(T...)" title="class or interface in java.util"><CODE>Arrays.asList(T...)</CODE></A>, the returned list is unmodifiable.

 <p>This is useful when a varargs method needs to use a signature such as
 <code>(Foo firstFoo, Foo secondFoo, Foo... moreFoos)</code>, in order to avoid
 overload ambiguity or to enforce a minimum argument count.

 <p>The returned list is serializable and implements <A HREF="http://java.sun.com/javase/6/docs/api/java/util/RandomAccess.html" title="class or interface in java.util"><CODE>RandomAccess</CODE></A>.
<P>
<DD><DL>
<DT><B>Parameters:</B><DD><CODE>first</CODE> - the first element<DD><CODE>second</CODE> - the second element<DD><CODE>rest</CODE> - an array of additional elements, possibly empty
<DT><B>Returns:</B><DD>an unmodifiable list containing the specified elements</DL>
</DD>
</DL>
<HR>

<A NAME="transform(java.util.List, com.google.common.base.Function)"><!-- --></A><H3>
transform</H3>
<PRE>
public static &lt;F,T&gt; <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;T&gt; <B>transform</B>(<A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html" title="class or interface in java.util">List</A>&lt;F&gt;&nbsp;fromList,
                                      <A HREF="../../../../com/google/common/base/Function.html" title="interface in com.google.common.base">Function</A>&lt;? super F,? extends T&gt;&nbsp;function)</PRE>
<DL>
<DD>Returns a list that applies <code>function</code> to each element of <code>fromList</code>. The returned list is a transformed view of <code>fromList</code>;
 changes to <code>fromList</code> will be reflected in the returned list and vice
 versa.

 <p>Since functions are not reversible, the transform is one-way and new
 items cannot be stored in the returned list. The <code>add</code>,
 <code>addAll</code> and <code>set</code> methods are unsupported in the returned
 list.

 <p>The function is applied lazily, invoked when needed. This is necessary
 for the returned list to be a view, but it means that the function will be
 applied many times for bulk operations like <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html#contains(java.lang.Object)" title="class or interface in java.util"><CODE>List.contains(java.lang.Object)</CODE></A> and
 <A HREF="http://java.sun.com/javase/6/docs/api/java/util/List.html#hashCode()" title="class or interface in java.util"><CODE>List.hashCode()</CODE></A>. For this to perform well, <code>function</code> should be
 fast. To avoid lazy evaluation when the returned list doesn't need to be a
 view, copy the returned list into a new list of your choosing.

 <p>If <code>fromList</code> implements <A HREF="http://java.sun.com/javase/6/docs/api/java/util/RandomAccess.html" title="class or interface in java.util"><CODE>RandomAccess</CODE></A>, so will the
 returned list. The returned list always implements <A HREF="http://java.sun.com/javase/6/docs/api/java/io/Serializable.html" title="class or interface in java.io"><CODE>Serializable</CODE></A>,
 but serialization will succeed only when <code>fromList</code> and
 <code>function</code> are serializable. The returned list is threadsafe if the
 supplied list and function are.
<P>
<DD><DL>
</DL>
</DD>
</DL>
<!-- ========= END OF CLASS DATA ========= -->
<HR>


<!-- ======= START OF BOTTOM NAVBAR ====== -->
<A NAME="navbar_bottom"><!-- --></A>
<A HREF="#skip-navbar_bottom" title="Skip navigation links"></A>
<TABLE BORDER="0" WIDTH="100%" CELLPADDING="1" CELLSPACING="0" SUMMARY="">
<TR>
<TD COLSPAN=2 BGCOLOR="#EEEEFF" CLASS="NavBarCell1">
<A NAME="navbar_bottom_firstrow"><!-- --></A>
<TABLE BORDER="0" CELLPADDING="0" CELLSPACING="3" SUMMARY="">
  <TR ALIGN="center" VALIGN="top">
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../overview-summary.html"><FONT CLASS="NavBarFont1"><B>Overview</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-summary.html"><FONT CLASS="NavBarFont1"><B>Package</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#FFFFFF" CLASS="NavBarCell1Rev"> &nbsp;<FONT CLASS="NavBarFont1Rev"><B>Class</B></FONT>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="package-tree.html"><FONT CLASS="NavBarFont1"><B>Tree</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../deprecated-list.html"><FONT CLASS="NavBarFont1"><B>Deprecated</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../index-all.html"><FONT CLASS="NavBarFont1"><B>Index</B></FONT></A>&nbsp;</TD>
  <TD BGCOLOR="#EEEEFF" CLASS="NavBarCell1">    <A HREF="../../../../help-doc.html"><FONT CLASS="NavBarFont1"><B>Help</B></FONT></A>&nbsp;</TD>
  </TR>
</TABLE>
</TD>
<TD ALIGN="right" VALIGN="top" ROWSPAN=3><EM>
</EM>
</TD>
</TR>

<TR>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
&nbsp;<A HREF="../../../../com/google/common/collect/ListMultimap.html" title="interface in com.google.common.collect"><B>PREV CLASS</B></A>&nbsp;
&nbsp;<A HREF="../../../../com/google/common/collect/MapConstraint.html" title="interface in com.google.common.collect"><B>NEXT CLASS</B></A></FONT></TD>
<TD BGCOLOR="white" CLASS="NavBarCell2"><FONT SIZE="-2">
  <A HREF="../../../../index.html?com/google/common/collect/Lists.html" target="_top"><B>FRAMES</B></A>  &nbsp;
&nbsp;<A HREF="Lists.html" target="_top"><B>NO FRAMES</B></A>  &nbsp;
&nbsp;<SCRIPT type="text/javascript">
  <!--
  if(window==top) {
    document.writeln('<A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>');
  }
  //-->
</SCRIPT>
<NOSCRIPT>
  <A HREF="../../../../allclasses-noframe.html"><B>All Classes</B></A>
</NOSCRIPT>


</FONT></TD>
</TR>
<TR>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
  SUMMARY:&nbsp;NESTED&nbsp;|&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_summary">METHOD</A></FONT></TD>
<TD VALIGN="top" CLASS="NavBarCell3"><FONT SIZE="-2">
DETAIL:&nbsp;FIELD&nbsp;|&nbsp;CONSTR&nbsp;|&nbsp;<A HREF="#method_detail">METHOD</A></FONT></TD>
</TR>
</TABLE>
<A NAME="skip-navbar_bottom"></A>
<!-- ======== END OF BOTTOM NAVBAR ======= -->

<HR>

</BODY>
</HTML>
